# Pact Gradle + Ktor + JUnit5 workshop

## Introduction

This workshop is aimed at demonstrating core features and benefits of contract testing with Pact.

Whilst contract testing can be applied retrospectively to systems, we will follow
the [consumer driven contracts](https://martinfowler.com/articles/consumerDrivenContracts.html) approach in this
workshop - where a new consumer and provider are created in parallel to evolve a service over time, especially where
there is some uncertainty with what is to be built.

This workshop should take from 1 to 2 hours, depending on how deep you want to go into each topic.

**Workshop outline**:

- [step 1: **create
  consumer**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step1#step-1---simple-consumer-calling-provider):
  Create our consumer before the Provider API even exists
- [step 2: **unit
  test**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step2#step-2---client-tested-but-integration-fails):
  Write a unit test for our consumer
- [step 3: **pact
  test**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step3#step-3---pact-to-the-rescue):
  Write a Pact test for our consumer
- [step 4: **pact
  verification**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step4#step-4---verify-the-provider):
  Verify the consumer pact with the Provider API
- [step 5: **fix
  consumer**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step5#step-5---back-to-the-client-we-go):
  Fix the consumer's bad assumptions about the Provider
- [step 6: **pact
  test**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step6#step-6---consumer-updates-contract-for-missing-products):
  Write a pact test for `404` (missing User) in consumer
- [step 7: **provider
  states**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step7#step-7---adding-the-missing-states):
  Update API to handle `404` case
- [step 8: **pact
  test**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step8#step-8---authorization): Write
  a pact test for the `401` case
- [step 9: **pact
  test**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step9#step-9---implement-authorisation-on-the-provider):
  Update API to handle `401` case
- [step 10: **request
  filters**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step10#step-10---request-filters-on-the-provider):
  Fix the provider to support the `401` case
- [step 11: **pact
  broker**](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step11#step-11---using-a-pact-broker):
  Implement a broker workflow for integration with CI/CD

_NOTE: Each step is tied to, and must be run within, a git branch, allowing you to progress through each stage
incrementally. For example, to move to step 2 run the following: `git checkout step2`_

## Learning objectives

If running this as a team workshop format, you may want to take a look through the [learning objectives](./LEARNING.md).

## Requirements

- JDK 11 or above
- Gradle 7
- Docker for step 11

## Scenario

There are two components in scope for our workshop.

1. Product Catalog website. It provides an interface to query the Product service for product information.
1. Product Service (Provider). Provides useful things about products, such as listing all products and getting the
   details of an individual product.

## Start

*Start at [step 1](https://gitlab.com/shodo.io/public/pact-workshop-gradle-ktor-junit5/tree/step1#step-1---simple-consumer-calling-provider)*
